> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.paradex.trade/api/testnet/token/list-tokens/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.paradex.trade/_mcp/server. # List tokens GET https://api.testnet.paradex.trade/v1/account/tokens Get all tokens for the authenticated account with optional filtering by kind and status. Reference: https://docs.paradex.trade/api/prod/token/list-tokens ## Authentication - `Authorization` header (required) — API Key authentication via header ## Request ### Query parameters - `kind` (string, optional) — Filter by token kind (e.g., 'jwt', 'api_key') - `with_invalid` (boolean, optional) — Include revoked and expired tokens ## Response ### 200 List of tokens - `results` (list of responses.ApiToken, optional) — Array of results ## Errors ### 401 Unauthorized Error Unauthorized - `data` (ResponsesApiErrorData, optional) — any additional data related to the error - `error` (enum, optional) — unique immutable string identifier for specific error - Allowed values: `VALIDATION_ERROR`, `BINDING_ERROR`, `INTERNAL_ERROR`, `NOT_FOUND`, `SERVICE_UNAVAILABLE`, `INVALID_REQUEST_PARAMETER`, `ORDER_ID_NOT_FOUND`, `ORDER_IS_CLOSED`, `ORDER_IS_NOT_OPEN`, `INVALID_ORDER_SIZE`, `CLIENT_ORDER_ID_NOT_FOUND`, `DUPLICATED_CLIENT_ID`, `INVALID_PRICE_PRECISION`, `INVALID_SYMBOL`, `INVALID_TOKEN`, `INVALID_ETHEREUM_ADDRESS`, `INVALID_ETHEREUM_SIGNATURE`, `INVALID_STARKNET_ADDRESS`, `INVALID_STARKNET_SIGNATURE`, `STARKNET_SIGNATURE_VERIFICATION_FAILED`, `BAD_STARKNET_REQUEST`, `ETHEREUM_SIGNER_MISMATCH`, `ETHEREUM_HASH_MISMATCH`, `NOT_ONBOARDED`, `INVALID_TIMESTAMP`, `INVALID_BLOCK_EXPIRATION`, `ACCOUNT_NOT_FOUND`, `INVALID_ORDER_SIGNATURE`, `PUBLIC_KEY_INVALID`, `UNAUTHORIZED_ETHEREUM_ADDRESS`, `UNAUTHORIZED_ERROR`, `ETHEREUM_ADDRESS_ALREADY_ONBOARDED`, `MARKET_NOT_FOUND`, `ALLOWLIST_ENTRY_NOT_FOUND`, `USERNAME_IN_USE`, `GEO_IP_BLOCK`, `ETHEREUM_ADDRESS_BLOCKED`, `PROGRAM_NOT_FOUND`, `PROGRAM_NOT_SUPPORTED`, `INVALID_DASHBOARD`, `MARKET_NOT_OPEN`, `INVALID_REFERRAL_CODE`, `REQUEST_NOT_ALLOWED`, `PARENT_ADDRESS_ALREADY_ONBOARDED`, `INVALID_PARENT_ACCOUNT`, `INVALID_VAULT_OPERATOR_CHAIN`, `VAULT_OPERATOR_ALREADY_ONBOARDED`, `VAULT_NAME_IN_USE`, `VAULT_NOT_FOUND`, `VAULT_STRATEGY_NOT_FOUND`, `VAULT_LIMIT_REACHED`, `BATCH_SIZE_OUT_OF_RANGE`, `ISOLATED_MARKET_ACCOUNT_MISMATCH`, `NO_ACCESS_TO_MARKET`, `POINTS_SUMMARY_NOT_FOUND`, `ALGO_ID_NOT_FOUND`, `INVALID_DERIVATION_PATH`, `PROFILE_STATS_NOT_FOUND`, `INVALID_CHAIN`, `INVALID_LAYERSWAP_SWAP`, `INVALID_RHINOFI_REQUEST`, `INVALID_RHINOFI_QUOTE`, `INVALID_RHINOFI_QUOTE_COMMIT`, `SOCIAL_USERNAME_IN_USE`, `INVALID_OAUTH_REQUEST`, `RPI_ACCOUNT_NOT_WHITELISTED`, `SYSTEM_STATUS_POST_ONLY`, `SYSTEM_STATUS_CANCEL_ONLY`, `INVALID_MARKETING_CODE`, `INVALID_JOIN_WAITLIST_REQUEST`, `TRANSACTION_NOT_FOUND`, `OFFER_NOT_FOUND`, `MARKET_MARGIN_RESTRICTED`, `NOT_UNIQUE`, `ACCOUNT_ALREADY_REFERRED`, `ONBOARDING_PERIOD_EXPIRED`, `ONBOARDING_RATE_LIMITED`, `SUBACCOUNTS_LIMIT_EXCEEDED`, `INSUFFICIENT_MIN_CHAIN_BALANCE`, `INVALID_SUBKEY`, `TOKEN_LIMIT_REACHED`, `INVALID_TOKEN_SCOPE`, `INSUFFICIENT_TRANSFERRABLE_XP`, `TRANSFER_LIMIT_REACHED` - `message` (string, optional) — detailed description of error and how to address it ## Types ### responses.ApiToken - `created_at` (integer, optional) — Token creation timestamp (nanoseconds since epoch) - `expiry_at` (integer, optional) — Expiration timestamp (nanoseconds since epoch) - `kind` (string, optional) — Token type (jwt, api_key, etc.) - `last_updated_at` (integer, optional) — Last modification timestamp (nanoseconds since epoch) - `lookup_id` (string, optional) — Identifier used for the token lookup - `name` (string, optional) — User-provided token name - `revoked_at` (integer, optional) — Revocation timestamp (nanoseconds since epoch, 0 if not revoked) - `token_id` (string, optional) — Unique ID for the auth token ### ResponsesApiErrorData any additional data related to the error ## Examples **Response** ```json { "results": [ { "created_at": 1640995200, "expiry_at": 1672531200, "kind": "string", "last_updated_at": 1640995200, "lookup_id": "uuid-123", "name": "My API Token", "revoked_at": 0, "token_id": "token_123" } ] } ``` **SDK Code** ```python import requests url = "https://api.testnet.paradex.trade/v1/account/tokens" headers = {"Authorization": ""} response = requests.get(url, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.testnet.paradex.trade/v1/account/tokens'; const options = {method: 'GET', headers: {Authorization: ''}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.testnet.paradex.trade/v1/account/tokens" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("Authorization", "") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.testnet.paradex.trade/v1/account/tokens") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["Authorization"] = '' response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.testnet.paradex.trade/v1/account/tokens") .header("Authorization", "") .asString(); ``` ```php request('GET', 'https://api.testnet.paradex.trade/v1/account/tokens', [ 'headers' => [ 'Authorization' => '', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.testnet.paradex.trade/v1/account/tokens"); var request = new RestRequest(Method.GET); request.AddHeader("Authorization", ""); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Authorization": ""] let request = NSMutableURLRequest(url: NSURL(string: "https://api.testnet.paradex.trade/v1/account/tokens")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```